#!/usr/bin/perl

# Copyright (C) 2003, 2004
# Emmanuel Saracco <esaracco@users.labs.libre-entreprise.org>
# Easter-eggs <http://www.easter-eggs.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307, USA.

require './clamav-lib.pl';
&clamav_check_acl ('quarantine_view');
&ReadParse ();

my $cp = $in{'cp'};
my $maxdays = $in{'maxdays'};
my $search_type = $in{'search_type'};
my $old_search_type = $in{'old_search_type'};
my $search_type_virus = ($search_type eq 'virus');
my $search_type_spam = ($search_type eq 'spam');
$search_type_virus = 1 if ($search_type eq '');
$cp = 0 if ($old_search_type ne '' and $search_type ne $old_search_type);

&header($text{'FORM_TITLE'}, "", undef, 1, 0);
print "<hr>\n";

&clamav_quarantine_main_check_config ();

print qq(<h1>$text{'QUARANTINE_PAGE_TITLE'}</h1>\n);
if (defined $in{'resended'})
{
  print qq(<h3>$text{'MSG_SUCCESS_STATUS_RESEND'}</h3>);
}
elsif (defined $in{'removed'})
{
  print qq(<h3>$text{'MSG_SUCCESS_STATUS_REMOVE'}</h3>);
}

print qq(<p>$text{'QUARANTINE_PAGE_DESCRIPTION'}</p>);

print qq(<h1>$text{'QUARANTINE_CLEANING'}</h1>);

print qq(<p>$text{'QUARANTINE_CRON_DESCRIPTION'}</p>);

if ($in{'next'})
{
  if ($in{'nopurge'} eq 'on')
  {
    $maxdays = '';
    &clamav_delete_cron ('purge');
    print qq(<p><b>$text{'MSG_SUCCESS_QUARANTINE_CRON_UPDATE'}</b></p>);
  }
  else
  {
    if ($maxdays and $maxdays !~ /^[0-9]+$/)
    {
        $maxdays = 0;
    
        print qq(<p><b>$text{'MSG_ERROR_QUARANTINE_UPDATE_MAXDAYS'}</b></p>);
    }
    else
    {
      my $hour = $in{'hour'};

      $hour = "*/$hour" if ($in{'every_hours'} and $in{'hour'});
      &clamav_set_cron_purge ($hour, $in{'day'}, $maxdays);
      print qq(<p><b>$text{'MSG_SUCCESS_QUARANTINE_CRON_UPDATE'}</b></p>);
    }
  }
}
elsif ($in{'delete'})
{
  foreach my $key (keys %in)
  {
    &clamav_remove_email ($in{$key}) if ($key =~ /quarantine_file/);
  }

  print qq(<h3>$text{'MSG_SUCCESS_STATUS_REMOVE'}</h3>);
}
elsif ($in{'delete_all'})
{
  # if clamav-milter
  if (&clamav_is_milter ())
  {
    system ("$all_path{'rm'}rm -rf $config{'clamav_milter_quarantine'}/*");
  }
  # if amavisd-new
  if (&clamav_is_amavisd_new ())
  {
    system ("$all_path{'rm'}rm -f $config{'clamav_quarantine'}/virus*");
  }
  # if amavis-ng
  else
  {
    system ("$all_path{'rm'}rm -f $config{'clamav_quarantine'}/*.{msg,log}");
  }

  print qq(<h3>$text{'MSG_SUCCESS_STATUS_PURGE_ALL'}</h3>);
}

@cron_line = &clamav_get_cron_settings ('purge');

print qq(<form method="POST" action="$scriptname">\n);
print &clamav_cron_settings_table ($cron_line[1], $cron_line[4]);
if ($maxdays eq '' and $cron_line[6] =~ /mtime \+([0-9]+) /)
{
  $maxdays = $1;
}

# maxdays
print qq(<p>);
print qq($text{'DELETE_MAX_DAYS'} <input type="text" name="maxdays" size="2" value="$maxdays"> $text{'DAYS'});
print qq(</p>);

# npurge
$checked = ($#cron_line <= 0) ? ' CHECKED' : '';
print qq(<p>);
print qq(<input type="checkbox" name="nopurge" value="on"$checked>);
print qq( $text{'QUARANTINE_PURGE_NEVER'});
print qq(</p>);

print qq(<p>);
if (&clamav_get_acl ('quarantine_delete') == 1)
{
  print qq(<input type="submit" name="next" value="$text{'APPLY'}">);
}
print qq(</p>);

print qq(</form>);

print qq(<h1>$text{'QUARANTINE_RESEARCH'}</h1>);

print qq(<p>$text{'QUARANTINE_RESEARCH_DESCRIPTION'}</p>);

print qq(
  <form action="quarantine_main.cgi" method="POST">
  <input type="hidden" name="total" value="$in{'total'}">
  <input type="hidden" name="cp" value="$cp">
  <input type="hidden" name="search" value="1">
  <input type="hidden" name="old_search_type" value="$search_type">
  <table border=0 bgcolor="silver">);
if (&clamav_is_amavisd_new ())
{
  print qq(<tr><td $cb><b>$text{'TYPE'}</b>:</td><td><input type="radio" name="search_type" value="virus");
  print (($search_type_virus) ? " CHECKED" : ''); 
  print qq(> $text{'VIRUSES'} <input type="radio" name="search_type" value="spam");
  print (($search_type_spam) ? " CHECKED" : '');
  print qq(> $text{'SPAMS'} </td></tr>);
}
else
{
  print qq(<input type="hidden" name="search_type" value="virus">);
}
if (not &clamav_is_milter ())
  {print qq(<tr><td $cb><b>$text{'VIRUS'}</b>:</td><td><input type="text" name="virus_name" value="$in{'virus_name'}"></td><td>&nbsp;</td></tr>)}
else
  {print qq(<input type="hidden" name="virus_name" value="">)}

print qq(<tr><td $cb><b>$text{'SENDER'}</b>:</td><td><input type="text" name="mail_from" value="$in{'mail_from'}"></td><td><input type="submit" value="$text{'SEARCH'}" name="search"></td></tr>
  <tr><td $cb><b>$text{'RECIPIENT'}</b>:</td><td><input type="text" name="mail_to" value="$in{'mail_to'}"></td><td>&nbsp;</td></tr>
  <tr><td $cb valign="top"><b>$text{'PERIOD'}</b>:</td><td colspan="2" nowrap valign="top">);
&clamav_get_period_chooser ($in{'day1'}, $in{'month1'}, $in{'year1'}, $in{'day2'}, $in{'month2'}, $in{'year2'});
print qq(
  </td></tr>
  </table>
  <p>
);

# if form submit, do the quarantine search
if ($in{'search'})
{
  if (&clamav_is_quarantine_repository_empty ())
  {
    print qq(<p><b>$text{'LINK_QUANRANTINE_EMPTY_PAGE'}</b></p>);
  }
  else
  {
    # if clamav-milter is installed
    if (&clamav_is_milter ())
    {
      $page_count = &clamav_print_quarantine_table_milter (
        $search_type,
        $in{'total'},
        $cp,
        $in{'virus_name'},
        $in{'mail_from'}, $in{'mail_to'}, 
	$in{'day1'}, $in{'month1'}, $in{'year1'}, 
	$in{'day2'}, $in{'month2'}, $in{'year2'});
    }
    # if amavis-ng is installed
    elsif (&clamav_is_amavis_ng ())
    {
      $page_count = &clamav_print_quarantine_table_amavis_ng (
        $in{'total'},
        $cp,
        $in{'virus_name'},
        $in{'mail_from'}, $in{'mail_to'}, 
	$in{'day1'}, $in{'month1'}, $in{'year1'}, 
	$in{'day2'}, $in{'month2'}, $in{'year2'});
    }
    # if amavisd-new is installed
    elsif (&clamav_is_amavisd_new ())
    {
      $page_count = &clamav_print_quarantine_table_amavisd_new (
        $search_type,
        $in{'total'},
        $cp,
        $in{'virus_name'},
        $in{'mail_from'}, $in{'mail_to'}, 
	$in{'day1'}, $in{'month1'}, $in{'year1'}, 
	$in{'day2'}, $in{'month2'}, $in{'year2'});
    }
  }

  &clamav_display_page_panel ($cp, $page_count);
}

print qq(</form>);
  
print qq(<hr>);
&footer("", $text{'RETURN_INDEX_MODULE'});
